#ifndef _OBSERVER_H_
#define _OBSERVER_H_

class Observable;

/*
 * This object defines the interface of the Observer as part of the 
 * Observer/Observable design pattern. Whenever the observed object changes
 * state it notifies all its observers by calling their "update" method.
 *
 * Author: Ziv Yaniv (zivy@cs.huji.ac.il)
 */


class Observer {
public:
          //method which is called whenever the observed object changes state.
         //userData may be NULL.
  virtual void update(Observable *o,void *userData) = 0;
};

#endif //_OBSERVER_H_
